package domain_test

import (
	"fmt"
	"testing"

	"gitea.dwysokinski.me/twhelp/dcbot/internal/domain"
	"github.com/stretchr/testify/assert"
)

func TestValidationError(t *testing.T) {
	t.Parallel()

	err := domain.ValidationError{
		Field: "test",
		Err: domain.MinError{
			Min: 25,
		},
	}
	var _ domain.Error = err
	assert.Equal(t, fmt.Sprintf("%s: %s", err.Field, err.Err.Error()), err.Error())
	assert.Equal(t, err.Error(), err.UserError())
	assert.ErrorIs(t, err, err.Err)
	assert.Equal(t, domain.ErrorCodeValidationError, err.Code())
}

func TestMinError(t *testing.T) {
	t.Parallel()

	err := domain.MinError{
		Min: 25,
	}
	var _ domain.Error = err
	assert.Equal(t, "must be no less than 25", err.Error())
	assert.Equal(t, err.Error(), err.UserError())
	assert.Equal(t, domain.ErrorCodeValidationError, err.Code())
}
