package service

import (
	"context"

	"gitea.dwysokinski.me/twhelp/dcbot/internal/twhelp"
)

//go:generate counterfeiter -generate

//counterfeiter:generate -o internal/mock/twhelp_client.gen.go . TWHelpClient
type TWHelpClient interface {
	ListVersions(ctx context.Context) ([]twhelp.Version, error)
	ListServers(ctx context.Context, version string, params twhelp.ListServersQueryParams) ([]twhelp.Server, error)
	GetServer(ctx context.Context, version, server string) (twhelp.Server, error)
	ListTribes(ctx context.Context, version, server string, params twhelp.ListTribesQueryParams) ([]twhelp.Tribe, error)
	GetTribeByID(ctx context.Context, version, server string, id int64) (twhelp.Tribe, error)
	ListEnnoblements(
		ctx context.Context,
		version, server string,
		queryParams twhelp.ListEnnoblementsQueryParams,
	) ([]twhelp.Ennoblement, error)
}
